#ifndef MS_FUNC_H
#define MS_FUNC_H

#include <psputilsforkernel.h>
#include <psputility.h>
#include <pspchnnlsv.h>

#ifdef __cplusplus
extern "C" {
#endif


#define	MS_GAME_NAME_MAX					(13+20)
#define	SFO_SIZE_HASH						16

#define	CLEAR_HASH(hash)					memset(hash,0,SFO_SIZE_HASH)

#define	MOD_UTILITY							"sceUtility_Driver"
#define	MOD_CHNNLSV							"sceChnnlsv"
#define	MOD_IOFILE							"sceIOFileManager"

#define	LIB_UTILITY							"sceUtility"
#define	LIB_CHNNLSV							MOD_CHNNLSV
#define	LIB_IOFILEK							"IoFileMgrForKernel"


#define	sceUtilitySavedataInitStart_org		( (int (*)(SceUtilitySavedataParam*))									hooktable[FNC_sceUtilitySavedataInitStart].restore.api		)
#define	sceUtilitySavedataShutdownStart_org	( (int (*)())															hooktable[FNC_sceUtilitySavedataShutdownStart].restore.api	)
#define	sceUtilitySavedataGetStatus_org		( (int (*)())															hooktable[FNC_sceUtilitySavedataGetStatus].restore.api		)

#define	sceChnnlsv_21BE78B4_org				( (int (*)(pspChnnlsvContext2 *ctx))									hooktable[FNC_sceChnnlsv_21BE78B4].restore.api				)
#define	sceSdSetMember_org					( (int (*)(pspChnnlsvContext2 *, u8 *, int))							hooktable[FNC_sceSdSetMember].restore.api					)
#define	sceSdCreateList_org					( (int (*)(pspChnnlsvContext2 *, int, int, u8 *, u8 *))					hooktable[FNC_sceSdCreateList].restore.api					)
#define	sceSdGetLastIndex_org				( (int (*)(pspChnnlsvContext1 *, u8 *, u8 *))							hooktable[FNC_sceSdGetLastIndex].restore.api				)
#define	sceSdSetIndex_org					( (int (*)(pspChnnlsvContext1 *, int))									hooktable[FNC_sceSdSetIndex].restore.api					)
#define	sceSdRemoveValue_org				( (int (*)(pspChnnlsvContext1 *ctx, u8 *, int))							hooktable[FNC_sceSdRemoveValue].restore.api					)

#define	sceIoRead_org						( (int (*)(SceUID, void*, SceSize))										hooktable[FNC_sceIoRead].restore.api						)


/*


sceChnnlsv_21BE78B4	->	sceChnnlsv_21BE78B4
sceSdSetMember		->	sceChnnlsv_850A7FA1
sceSdCreateList		->	sceChnnlsv_ABFDFC8B
sceSdGetLastIndex	->	sceChnnlsv_C4C494F8
sceSdSetIndex		->	sceChnnlsv_E7833020
sceSdRemoveValue	->	sceChnnlsv_F21A1FCA

[Í] Z[uf[^
1. sceSdCreateList
2. sceSdSetIndex
3. sceSdRemoveValue
4. sceSdSetMember
5. sceSdRemoveValue
6. sceChnnlsv_21BE78B4
7. sceSdGetLastIndex

[] Z[uf[^
1. sceSdSetIndex
2. sceSdCreateList
3. sceSdRemoveValue
4. sceSdRemoveValue
5. sceSdSetMember
6. sceChnnlsv_21BE78B4
7. sceSdGetLastIndex

[jmF] PARAM.SFO ̂̂̃nbV
1. sceSdSetIndex
2. sceSdRemoveValue
3. sceSdGetLastIndex

֐̎s𒲂ׂ邱Ƃ
݂̏󋵂

*/





typedef enum
{
	Status_Hook,
	Status_Check,
	Status_Dump,
} Status_Mode;





enum save_type
{
	data_none = 0,
	data_load,
	data_save,
};



enum
{
	FNC_sceUtilitySavedataInitStart,
	FNC_sceUtilitySavedataShutdownStart,
	FNC_sceUtilitySavedataGetStatus,
	
	FNC_sceChnnlsv_21BE78B4,
	FNC_sceSdSetMember,
	FNC_sceSdCreateList,
	FNC_sceSdGetLastIndex,
	FNC_sceSdSetIndex,
	FNC_sceSdRemoveValue,
	FNC_sceIoRead,
};





void Check_Module_Status();
bool Change_Hook_Status(Status_Mode mode , bool val);


#define	Dump()			Change_Hook_Status(Status_Dump,false);

#define Is_Hooked()		Change_Hook_Status(Status_Check,false)
#define	Is_Dumped()		Change_Hook_Status(Status_Check,true)

#define	Hook()			Change_Hook_Status(Status_Hook,true)
#define	unHook()		Change_Hook_Status(Status_Hook,false)


int _sceUtilitySavedataInitStart(SceUtilitySavedataParam* params);
int _sceUtilitySavedataShutdownStart(void);
int _sceUtilitySavedataGetStatus(void);

int _sceChnnlsv_21BE78B4 (pspChnnlsvContext2 *ctx);
int _sceSdSetMember(pspChnnlsvContext2 *ctx, unsigned char *data, int len);
int _sceSdCreateList(pspChnnlsvContext2 *ctx, int mode1, int mode2, unsigned char *hashkey, unsigned char *cipherkey);
int _sceSdGetLastIndex(pspChnnlsvContext1 *ctx, unsigned char *hash, unsigned char *cryptkey);
int _sceSdSetIndex(pspChnnlsvContext1 *ctx, int mode);
int _sceSdRemoveValue(pspChnnlsvContext1 *ctx, unsigned char *data, int len);


int _sceIoRead (SceUID fd, void *data, SceSize size) ;




#ifdef __cplusplus
}
#endif

#endif

