#ifndef LIB_HOOK_H
#define LIB_HOOK_H

#include <psputilsforkernel.h>
#include <psputility.h>
#include <pspchnnlsv.h>

#ifdef __cplusplus
extern "C" {
#endif

#define OPCODE_JAL					0x0C000000
#define OPCODE_J					0x08000000
#define OPCODE_JR_RA				0x03e00008
#define OPCODE_NOP					0x00000000
#define OPCODE_SC					0x0000000C
#define OPCODE_ADDI					0x24000000


#define MIPS_JAL(IMM)				(OPCODE_JAL + (u32)(IMM)&0x3FFFFFF)
#define MIPS_ADDI(RT,RS,IMM)		(OPCODE_ADDI|(RS<<21)|(RT<<16)|((u32)(IMM)&0xffff))
//#define MAKE_CALL(a, f)				_sw(OPCODE_JAL | (((u32)(f) >> 2)  & 0x03ffffff), a);
#define MAKE_CALL(a, f) 			_sw(OPCODE_JAL | (((u32)(f) & 0x3FFFFFFF) >> 2), a);
#define MAKE_JUMP(a, f) 			_sw(OPCODE_J   | (((u32)(f) & 0x3FFFFFFF) >> 2), a); 
#define MAKE_SYSCALL(a, n) 			_sw(OPCODE_SC | (n << 6), a);
#define JUMP_TARGET(x) 				(0x80000000 | ((x & 0x03FFFFFF) << 2))

#define REDIRECT_FUNCTION(a, f) 	_sw(OPCODE_J | (((u32)(f) >> 2)  & 0x03ffffff), a);  _sw(OPCODE_NOP, a+4);
#define MAKE_DUMMY_FUNCTION0(a) 	_sw(0x03e00008, a); _sw(0x00001021, a+4);
#define MAKE_DUMMY_FUNCTION1(a)		_sw(0x03e00008, a); _sw(0x24020001, a+4);

//void ClearCaches()
//{
//	sceKernelDcacheWBinvAll();
//	sceKernelIcacheClearAll();
//}



void **hookFindExportAddr( const char *modname, const char *libname, unsigned int nid );
void **hookFindSyscallAddr( void **addr );
void hookFunc( void **addr, void *hookfunc );

#ifdef __cplusplus
}
#endif

#endif
